
%define srcname	openoffice.org
%define ooname	%srcname-go-ooo
%define unopkg	%{_libdir}/%{ooodir}/program/unopkg
%define binpkg	%nil
%define ooo_version %(rpm -q --qf '%%{version}' %{ooname}-devel 2>/dev/null)
%define ooo_shortver %(echo %ooo_version | perl -p -e 's/^([^\\\.]+\\\.[^\\\.]+)\\\..*/\\\1/')
%define ooodir	ooo-%{ooo_shortver}

# This is a hack, but we have to follow openoffice.org.spec naming
%ifarch x86_64
%define ooname %{srcname}64-go-ooo
%define ooodir	ooo-%{ooo_shortver}_64
%define binpkg -n %{binname}
%endif

%define orgname	%{srcname}-voikko
%define binname	%{ooname}-voikko
%define name	%{srcname}-go-ooo-voikko

# Please update openoffice.org-voikko as well if necessary
%define version	1.2
%define rel	1

%ifarch %ix86
%define unopkgname	openoffice.org-voikko-Linux_x86-%version.uno.pkg
%else
%define unopkgname	openoffice.org-voikko-Linux_%_arch-%version.uno.pkg
%endif

%define ooo_version	%(rpm -q --qf '%%{version}' %{ooname}-devel 2>/dev/null)

# NOTE: There is a duplicate package section below for openoffice.org64 naming
#       hack.

Summary:	Finnish spellchecker and hyphenator for OpenOffice.org
Name:		%name
Version:	%version
Release:	%mkrel %rel
License:	LGPL
Group:		Office
URL:            http://voikko.sourceforge.net/
Source:         http://downloads.sourceforge.net/voikko/%orgname-%version.tar.bz2
BuildRoot:	%{_tmppath}/%{name}-root
BuildRequires:	%ooname-devel
BuildRequires:	zip
BuildRequires:	voikko-devel
Requires:	locales-fi
# Binaries are hidden inside a zip, so automatic dependencies won't work
Requires:	%{mklibname voikko 1}
Requires:	voikko-dictionary
Requires:	%ooname = %ooo_version
Requires(pre):	%ooname = %ooo_version
Requires(post):	%ooname = %ooo_version
Requires(preun):	%ooname = %ooo_version

%description
Finnish spellchecker and hyphenator component for OpenOffice.org.

Usually Voikko is automatically activated after the installation. If
that won't happen, you can manually activate it from the Writing
Aids section of the OpenOffice.org options.

%ifarch x86_64
%package -n %binname
Summary:        Finnish spellchecker and hyphenator for OpenOffice.org
Group:		Office
Requires:       locales-fi
# Binaries are hidden inside a zip, so automatic dependencies won't work
Requires:       %{mklibname voikko 1}
Requires:       voikko-dictionary
Requires:       %ooname = %ooo_version
Requires(pre):  %ooname = %ooo_version
Requires(post): %ooname = %ooo_version
Requires(preun):        %ooname = %ooo_version

%description -n %binname
Finnish spellchecker and hyphenator component for OpenOffice.org.

Usually Voikko is automatically activated after the installation. If
that won't happen, you can manually activate it from the Writing
Aids section of the OpenOffice.org options.
%endif

%prep
%setup -q -n %orgname-%version

%build
# Calling setsdkenv_unix requires user input, so we use the
# setsdkenv_unix.sh which appears to be preset correctly.
# However, it doesn't seem to be exporting the variables properly
# so we source it and set shell options temporarily to normal
# behaviour. HOME is reset, as setsdkenv_unix.sh sets some output
# path to $HOME.
set +xe
HOME=$(pwd) . %{_libdir}/%{ooodir}/sdk/setsdkenv_unix.sh
set -xe

# Build fails otherwise
export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:%{_libdir}/%{ooodir}/program

%make

%install
rm -rf %{buildroot}

install -d -m755 %{buildroot}%{_libdir}/%{binname}
install -m644 build/%{unopkgname} %{buildroot}%{_libdir}/%{binname}

%clean
rm -rf %{buildroot}

%pre %binpkg
if ! [ -x %unopkg ]; then
	echo "ERROR: Compatible version of OpenOffice.org is not installed, aborting the"
	echo "       installation or upgrade of %{binname}!"
	exit 1
fi

%posttrans %binpkg
if [ -x %unopkg ]; then
	# make sure no other version is installed
	for pkg in $(%unopkg list --shared 2>/dev/null | sed -ne 's/^Name: \(oo2-voikko.*\)/\1/p' -e 's/^Name: \(openoffice.org-voikko.*\)/\1/p'); do
		%unopkg remove --shared $pkg
	done
	%unopkg add --shared %{_libdir}/%{binname}/%{unopkgname}
fi

%preun %binpkg
if [ -x %unopkg ]; then
	%unopkg remove --shared %{unopkgname}
fi

%files %binpkg
%defattr(-,root,root)
%doc COPYING.gpl
%{_libdir}/%{binname}



%changelog
* Wed Feb 28 2007 Anssi Hannula <anssi@mandriva.org> 1.2-1mdv2007.0
+ Revision: 128885
- adapt for openoffice.org-go-ooo

* Wed Feb 28 2007 Anssi Hannula <anssi@mandriva.org> 1.2-3mdv2007.1
+ Revision: 127331
- allow co-installation with openoffice.org(64)-go-ooo-voikko
- update package name in %%pre incompatibility error message

* Mon Feb 12 2007 Anssi Hannula <anssi@mandriva.org> 1.2-2mdv2007.1
+ Revision: 119899
- adapt .spec for building with different OOo versions
- add Requires(post) to x86_64 package too
- rebuild for new openoffice.org
- update URL

* Sat Nov 11 2006 Anssi Hannula <anssi@mandriva.org> 1.2-1mdv2007.1
+ Revision: 83154
- 1.2
- adapt spec for upstream name change
- Import openoffice.org-voikko

